package meerkat.bulletinboard.webapp;


import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;

import meerkat.rest.Constants;
import meerkat.rest.Constants.*;

import com.google.protobuf.ByteString;

import meerkat.bulletinboard.sqlserver.SQLiteBulletinBoardServer;
import meerkat.comm.CommunicationException;
import meerkat.protobuf.Crypto.*;
import meerkat.protobuf.Voting.*;
import meerkat.rest.*;

@Path("/test")
public class SQLiteServerTest {
	
	private static String PROP_GETTY_URL = "gretty.httpBaseURI";
	private static String BASE_URL = "http://localhost:8081";//System.getProperty(PROP_GETTY_URL);
	private static String SQL_SERVER_URL = BASE_URL + "/SQLServer";
	
	@GET
	public Response main(){
		byte[] b1 = {(byte) 1, (byte)2, (byte) 3, (byte) 4};
		byte[] b2 = {(byte) 11, (byte)12, (byte) 13, (byte) 14};
		byte[] b3 = {(byte) 21, (byte)22, (byte) 23, (byte) 24};
		
		Response response;
		
		BulletinBoardMessage msg;
		try{
			msg = BulletinBoardMessage.newBuilder()
					.setMsg(UnsignedBulletinBoardMessage.newBuilder()
							.addTags("Signature")
							.addTags("Trustee")
							.setData(ByteString.copyFrom(b1))
							.build())
					.setSig(Signature.newBuilder()
							.setType(SignatureType.DSA)
							.setData(ByteString.copyFrom(b2))
							.setSignerId(ByteString.copyFrom(b3))
							.build())
					.build();
			
//			SQLiteBulletinBoardServer bbs = new SQLiteBulletinBoardServer();
//		
//		
//			bbs.init();
//			
//			bbs.postMessage(msg);
//			response = Response.status(Status.OK).entity(bbs.testPrint()).build();
//			
//			bbs.close();
			
			 
			
			Client client = ClientBuilder.newClient()
					.register(ProtobufMessageBodyWriter.class)
					.register(ProtobufMessageBodyWriter.class);
			WebTarget webTarget = client.target(SQL_SERVER_URL);
			response = webTarget.request(MediaType.TEXT_HTML).post(Entity.entity(msg, Constants.MEDIATYPE_PROTOBUF));
			
		} catch(Exception e){
			response = Response.status(Status.OK).entity(e.getMessage()).build();;
		}
		
//		response = Response.status(Status.OK).entity("OK").build();
		
		return response;
	}
	
}
